import java.awt.*;
import java.awt.event.*;
public class Margistusala2 extends Panel implements MouseListener{
  int kogupikkus=50000;
  double algusprotsent=0.1, loppprotsent=0.4;
  Color margistusvarv=Color.black;
  public Margistusala2(){
    addMouseListener(this);
  }
  public void paint(Graphics g){
    g.setColor(margistusvarv);
    g.fillRect(
      (int)(algusprotsent*getWidth()), 0, 
      (int)((loppprotsent-algusprotsent)*getWidth()), getHeight()
    );
  }
  public void mousePressed(MouseEvent e){
    algusprotsent=e.getX()/(double)getWidth();
  }
  public void mouseReleased(MouseEvent e){
    loppprotsent=e.getX()/(double)getWidth();
    if(loppprotsent<algusprotsent){
      double abi=algusprotsent; algusprotsent=loppprotsent; loppprotsent=abi;
    }
    repaint();
  }
  public void mouseClicked(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public static void main(String[] arg){ //ala testimine
    Frame f=new Frame();
    f.add(new Margistusala2());
    f.setSize(300, 200);
    f.setVisible(true);
  }
}