import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.sound.sampled.*;
public class Digiheliredaktor2 extends Panel implements ActionListener{
  byte[] andmed;
  byte[] puhver;
  AudioFormat formaat;

  Button mangi=new Button("Mngi");
  Button lae=new Button("Lae fail");
  TextField tfLae=new TextField("esimene.wav", 20);
  Button salvesta=new Button("Salvesta fail");
  TextField tfSalvesta=new TextField("salvestis.wav", 20);
  SourceDataLine kanal;
  public Digiheliredaktor2(){
    Panel p=new Panel();
    p.add(mangi);
    Panel alapaneel=new Panel();
    alapaneel.add(lae);
    alapaneel.add(tfLae);
    alapaneel.add(salvesta);
    alapaneel.add(tfSalvesta);
    setLayout(new BorderLayout());
    add(p, BorderLayout.NORTH);
    add(ala, BorderLayout.CENTER);
    add(alapaneel, BorderLayout.SOUTH);
    lae.addActionListener(this);
    salvesta.addActionListener(this);
    mangi.addActionListener(this);
  }
  public void actionPerformed(ActionEvent e){
    if(e.getSource()==lae){laeFail(); }
    if(e.getSource()==salvesta){salvestaFail(); }
    if(e.getSource()==mangi){mangi(); }
  }
  public void laeFail(){
   try{
    AudioInputStream sisse=AudioSystem.getAudioInputStream(new File(tfLae.getText())); 
    ByteArrayOutputStream malu=new ByteArrayOutputStream();
    int nr=sisse.read();
    while(nr!=-1){      //loetakse voo sisu mlupuhvrisse
      malu.write(nr);
      nr=sisse.read();
    }
    andmed=malu.toByteArray();
    //ala.kogupikkus=andmed.length;
    ala.seaAndmed(andmed);
    formaat=sisse.getFormat();
   }catch(Exception viga){
     viga.printStackTrace();
   }
  }
  
  public void salvestaFail(){
   try{
      AudioInputStream ais=new AudioInputStream(
       new ByteArrayInputStream(andmed), formaat, andmed.length
     );
    AudioSystem.write(ais, AudioFileFormat.Type.WAVE, new File(tfSalvesta.getText()));
   }catch(Exception viga){
     viga.printStackTrace();
   }
  }
  
  public void loikaLoik(){
    byte[] uus=new byte[andmed.length-(ala.loppKaader()-ala.algKaader())];
    puhver=new byte[ala.loppKaader()-ala.algKaader()];

    System.arraycopy(andmed, ala.algKaader(), puhver, 0, (ala.loppKaader()-ala.algKaader())); 
    System.arraycopy(andmed, 0, uus, 0, ala.algKaader());
    System.arraycopy(andmed, ala.loppKaader(), uus, 
                     ala.algKaader(), andmed.length-ala.loppKaader());
    andmed=uus;
    uuendaAla();   



  }
  
  
  public void tyhjendaLoik(){
    for(int i=ala.algKaader(); i<=ala.loppKaader(); i++){
      andmed[i]=(byte)0;
    }
  }
  
  public void kopeeriLoik(){
    puhver=new byte[ala.loppKaader()-ala.algKaader()];
    for(int i=0; i<puhver.length; i++){
      puhver[i]=andmed[ala.algKaader()+i];
    }
  }
  
  public void kleebiLoik(){
    if(puhver==null)return;
    byte[] uus=new byte[
       andmed.length+puhver.length-(ala.loppKaader()-ala.algKaader())];
    System.arraycopy(andmed, 0, uus, 0, ala.algKaader());
    System.arraycopy(puhver, 0, uus, ala.algKaader(), puhver.length);
    System.arraycopy(andmed, ala.loppKaader(), uus, 
               ala.algKaader()+puhver.length, andmed.length-ala.loppKaader());
    andmed=uus;
    uuendaAla();
  }
  
  /**
  * Joonistusala uuendamine prast andmete muutust.
  */
  void uuendaAla(){
    //ala.kogupikkus=andmed.length;
    ala.seaAndmed(andmed);
    ala.algusprotsent=0;
    ala.loppprotsent=0;
    ala.repaint();
  }
  
  public void kirjutaLoikYle(){
    if(puhver==null)return;
    for(int i=0; i<puhver.length; i++){
      andmed[ala.algKaader()+i]=puhver[i];
    }
  }
  
  public void mangi(){
    try{  //Kontrollib, et opssteemilt on vimalik kanal ksida.
     kanal=(SourceDataLine)AudioSystem.getLine(
      new DataLine.Info(SourceDataLine.class, formaat, AudioSystem.NOT_SPECIFIED)
     );
     kanal.open();
     kanal.start();
     kanal.write(andmed, 0, andmed.length);
     kanal.drain();
     kanal.close();
    }catch(Exception ex){
      ex.printStackTrace();
    }
  }
  
  public void mangiLoik(){
    try{  //Kontrollib, et opssteemilt on vimalik kanal ksida.
     kanal=(SourceDataLine)AudioSystem.getLine(
      new DataLine.Info(SourceDataLine.class, formaat, AudioSystem.NOT_SPECIFIED)
     );
     kanal.open();
     kanal.start();
     kanal.write(andmed, ala.algKaader(), ala.loppKaader()-ala.algKaader());
     kanal.drain();
     kanal.close();
    }catch(Exception ex){
      ex.printStackTrace();
    }  
  }
  
  // siit siis algab minu panus sellesse heliredaktorisse;)
  
  	public void pikemaks(){
  		try {	
 			AudioInputStream sisse=AudioSystem.getAudioInputStream(new File(tfLae.getText().trim())); 
 			ByteArrayOutputStream malu=new ByteArrayOutputStream();
 			int nr=sisse.read();
 			while(nr!=-1){      //loetakse voo sisu mlupuhvrisse
      				malu.write(nr);
      				nr=sisse.read();
    			}
			int kordadeArv=Integer.parseInt(tfPikemaks.getText());
			int jarg=0;
    			byte maluBaidid[]=malu.toByteArray();
    			byte maluTagurpidi[]=new byte[maluBaidid.length];
    			byte maluPikem[]=new byte[maluBaidid.length*kordadeArv];
    	//luuakse puhver tagurpidiste jrjestustega
    			for(nr=0; nr<maluBaidid.length; nr++){   
				maluTagurpidi[maluBaidid.length-nr-1]=maluBaidid[nr];
    			}
    			for (int a=0; a<Math.floor(((float)kordadeArv/2)+0.5);a++){
 				for (nr=0; nr<maluTagurpidi.length; nr++){
 					maluPikem[jarg]=maluTagurpidi[nr];
 					jarg++;
 				}
 				if(jarg==maluBaidid.length*kordadeArv){
 					break;	
 				}
    				for(nr=0; nr<maluBaidid.length; nr++) {
					maluPikem[jarg]=maluBaidid[nr];
					jarg++;
	    			}
	    		
	    		}
	    		andmed=maluPikem;
	    	}catch(Exception viga){
	    		System.out.println(viga);
	    		System.out.println(viga.getMessage());
	    		viga.printStackTrace();	
	    	}
  	}
  
  public static void main(String[] argumendid){
    Frame f=new Frame();
    f.add(new Digiheliredaktor2());
    f.setSize(600, 300);
    f.setVisible(true);
    f.addWindowListener(new Raamikuular());
  }
}

class Raamikuular extends WindowAdapter{
	public void windowClosing(WindowEvent e) {
		System.out.println("X-st kinni");
		System.exit(0);
	}
}
