
/**
 * User: Mart Karu
 * Date: 22.04.2003
 * Time: 12:51:10
 */
public class Utiil
{
    /**
     * Tagastab piksli punase vrtuse
     * @param piksel
     * @return
     */
    public static int getR(int piksel)
    {
        return ((piksel >> 16) & 0xFF);
    }

    /**
     * Tagastab piksli rohelise vrtuse
     * @param piksel
     * @return
     */
    public static int getG(int piksel)
    {
        return ((piksel >> 8) & 0xFF);
    }

    /**
     * Tagastab piksli sinise vrtuse
     * @param piksel
     * @return
     */
    public static int getB(int piksel)
    {
        return (piksel & 0xFF);
    }

    /**
     * Ehitab vrvikomponentidest piksli
     * @param r punane
     * @param g roheline
     * @param b sinine
     * @return
     */
    public static int ehitaPiksel(int r, int g, int b)
    {
        return (255 << 24 + (r << 16) + (g << 8) + b);
    }
}
