import java.awt.*;
import java.awt.event.*;

public class Margistusala2 extends Panel implements MouseListener{
	private int kogupikkus=50000;
	byte[] andmed;  //heli andmed
	double algusprotsent=0.1, loppprotsent=0.4;
	Color margistusvarv=Color.black;
	

	public Margistusala2(){
		addMouseListener(this);
	}

	public void paint(Graphics g){
		g.setColor(margistusvarv);
		g.fillRect(
			(int)(algusprotsent*getWidth()), 0, 
			(int)((loppprotsent-algusprotsent)*getWidth()), getHeight()
		);
		g.drawLine(  //kursor
			(int)(algusprotsent*getWidth()), getHeight()/2, 
			(int)(algusprotsent*getWidth()), getHeight()
		);
		if(andmed!=null){
			for(int i=1; i<andmed.length; i++){
				g.drawLine(
					(int)((i-1.0)/andmed.length*getWidth()), 
					(int)(getHeight()/2-andmed[i-1]/150.0*getHeight()),
					(int)(((double)i)/andmed.length*getWidth()), 
					(int)(getHeight()/2-andmed[i]/150.0*getHeight())          
				);
			}
		}
	}

	public void seaAndmed(byte[] uuedAndmed){
		andmed=uuedAndmed;
		kogupikkus=andmed.length;
	}
  
	public void mousePressed(MouseEvent e){
		algusprotsent=e.getX()/(double)getWidth();
	}

	public void mouseReleased(MouseEvent e){
		loppprotsent=e.getX()/(double)getWidth();
		if(loppprotsent<algusprotsent){
			double abi=algusprotsent; algusprotsent=loppprotsent; loppprotsent=abi;
		}
		repaint();
	}

	public int algKaader(){
		return (int)(algusprotsent*kogupikkus);
	}

	public int loppKaader(){
		return (int)(loppprotsent*kogupikkus);
	}
	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	public static void main(String[] arg){ //ala testimine
		Frame f=new Frame();
		f.add(new Margistusala2());
		f.setSize(300, 200);
		f.setVisible(true);
	}
}