import java.applet.Applet;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

public class Murdjoon5 extends Applet implements ActionListener{

  Button yles=new Button("les");
  Button alla=new Button("Alla");
  Button vasakule=new Button("Vasakule");
  Button paremale=new Button("Paremale");
  Button suurenda=new Button("Suurenda");
  Button vahenda=new Button("Vhenda");
  LinkedList punktid=new LinkedList();
  int pikimaJoonePikkus=5;
  int vx=286, vy=120, vsamm=5;
  int ekeskx, ekesky;
  double suurendus=1, suurenduskordaja=1.1;
  
  public Murdjoon5(){
    add(yles);
    add(alla);
    add(vasakule);
    add(paremale);
    add(suurenda);
    add(vahenda);
    yles.addActionListener(this);
    alla.addActionListener(this);
    vasakule.addActionListener(this);
    paremale.addActionListener(this);
    suurenda.addActionListener(this);
    vahenda.addActionListener(this);

    punktid.add(new Point(186, 249));
    punktid.add(new Point(198, 180));
    punktid.add(new Point(170, 197));
    punktid.add(new Point(129, 155));
    punktid.add(new Point(129, 61));
    punktid.add(new Point(219, 21));
    punktid.add(new Point(267, 27));
    punktid.add(new Point(270, 6));
    punktid.add(new Point(352, 17));
    punktid.add(new Point(455, 33));
    lisaVahePunktid();
  }
  
  public void actionPerformed(ActionEvent e){
    if(e.getSource()==yles)    {vy-=vsamm;}
    if(e.getSource()==alla)    {vy+=vsamm;}
    if(e.getSource()==vasakule){vx-=vsamm;}
    if(e.getSource()==paremale){vx+=vsamm;}
    if(e.getSource()==suurenda){suurendus*=suurenduskordaja;}
    if(e.getSource()==vahenda){suurendus/=suurenduskordaja;}
    repaint();
  }

  public void lisaVahePunktid(){
   int koht=0;
   while(koht+1<punktid.size()){
    Point p1=(Point)punktid.get(koht);
    Point p2=(Point)punktid.get(koht+1);
    double kaugus=p1.distance(p2);
    if(kaugus>pikimaJoonePikkus){
      Point p3=new Point(
        (p1.x+p2.x)/2+(int)((Math.random()-0.5)*0.4*kaugus),
        (p1.y+p2.y)/2+(int)((Math.random()-0.5)*0.4*kaugus)
      );
      punktid.add(punktid.indexOf(p2), p3); 
      if(p1.distance(p3)<=pikimaJoonePikkus){
        koht=koht+1;
      }
    } else {
      koht=koht+1;
    }
   } 
    
  }
  
  int ekraaniX(int maailmaX){
    return ekeskx+(int)((maailmaX-vx)*suurendus);
  }
  
  int ekraaniY(int maailmaY){
    return ekesky+(int)((maailmaY-vy)*suurendus);
  }

  public void paint(Graphics g){
    ekeskx=getWidth()/2;
    ekesky=getHeight()/2;
    for(int i=0; i<punktid.size()-1; i++){
      Point p1=(Point)punktid.get(i);
      Point p2=(Point)punktid.get(i+1);
      g.drawLine(ekraaniX(p1.x), ekraaniY(p1.y), 
                 ekraaniX(p2.x), ekraaniY(p2.y));
    }
  }

  public static void main(String[] argumendid){
    Frame f=new Frame();
    f.add(new Murdjoon5());
    f.setSize(300, 300);
    f.setVisible(true);
  }
}