import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;


public class Pildiredaktor4 extends Applet 
   implements MouseListener{
  BufferedImage pilt=new BufferedImage(300, 300, BufferedImage.TYPE_INT_RGB);
  Graphics2D piltg=pilt.createGraphics();
  String[] varvinimed={"Punane", "Sinine", "Kollane"};
  Color[] varvid={Color.red, Color.blue, Color.yellow};
  String[] kujundinimed={"Thi ovaal", "Tis ovaal", 
                   "Thi ristklik", "Tis ristklik", "Joon"};
  int allaX, allaY;
  Choice varvivalik=new Choice();
  Choice kujundivalik=new Choice();
  

  public Pildiredaktor4(){
    addMouseListener(this);
    for(int i=0; i<varvinimed.length; i++){
      varvivalik.addItem(varvinimed[i]);
    }
    for(int i=0; i<kujundinimed.length; i++){
      kujundivalik.addItem(kujundinimed[i]);
    }
    add(varvivalik);
    add(kujundivalik);
  }
  
  
  public void paint(Graphics g){
    g.drawImage(pilt, 0, 0, this);
  }
  public void update(Graphics g){paint(g);} //hoiab vilkumise eemal

  public void mousePressed(MouseEvent e){
    allaX=e.getX();
    allaY=e.getY();
  }
  public void mouseReleased(MouseEvent e){
    piltg.setColor(varvid[varvivalik.getSelectedIndex()]);
    int vyx=Math.min(allaX, e.getX());
    int vyy=Math.min(allaY, e.getY());
    int laius=Math.abs(allaX-e.getX());
    int korgus=Math.abs(allaY-e.getY());
    if(kujundivalik.getSelectedIndex()==0){
      piltg.drawOval(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==1){
      piltg.fillOval(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==2){
      piltg.drawRect(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==3){
      piltg.fillRect(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==4){
      piltg.drawLine(allaX, allaY, e.getX(), e.getY());
    }

    repaint();
  }
  public void mouseClicked(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  
  public static void main(String[] arg){
    Frame f=new Frame();
    f.add(new Pildiredaktor4());
    f.setSize(200, 200);
    f.setVisible(true);
  }
}