/*
 * (C)(P)2003 Mart Karu, TPU, <karu@metal.ee>
 *
 * User: karu
 * Date: Apr 23, 2003
 * Time: 2:08:34 AM
 */

public class MasterPlayerThread extends Thread
{
	private EditorRaam editor = null;
	private boolean jookseb = false;

	public MasterPlayerThread( EditorRaam editor )
	{
		this.editor = editor;
	}

	public void run()
	{
		jookseb = true;

		// NB: kiirus on suvaline!
		int sleep = ( int ) ( ( Float.parseFloat( editor.getWidth() + "" ) / Float.parseFloat( editor.getMaxPikkus() + "" ) ) * 100 );
		System.out.println( sleep );

		while ( jookseb )
		{
			for ( int i = 0; ( i < editor.getWidth() ) && jookseb; i++ )
			{
				editor.setMangijaPositsioon( i );

				for ( int j = 0; j < editor.getHeliJupid().size(); j++ )
				{
					HeliJupp jupp = ( HeliJupp ) editor.getHeliJupid().get( j );
					if ( jupp.getLocation().getX() == i )
						jupp.mangiHeli();
				}
				try
				{
					this.sleep( sleep );
				}
				catch ( InterruptedException e )
				{
					e.printStackTrace();
				}
			}
		}
	}

	public void seisata()
	{
		jookseb = false;
	}
}
