import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;
import java.applet.Applet;
import java.io.*;

public class PildiredaktorS extends Applet implements MouseListener, ActionListener{

	int pildilaius=800, pildikorgus=600;	
	int suurendus=2;

	Button nupp1=new Button("Salvesta");
	Button nupp2=new Button("Ava pilt");
	TextField tf=new TextField("", 20);	
	String nimi="pilt.jpg";

	BufferedImage pilt=new BufferedImage(pildilaius, pildikorgus, BufferedImage.TYPE_INT_RGB);
	Graphics2D piltg=pilt.createGraphics();

	BufferedImage puhver;

	Choice varvivalik=new Choice();
	String[] varvinimed={"Punane", "Sinine", "Kollane"};
	Color[] varvid={Color.red, Color.blue, Color.yellow};

	Choice kujundivalik=new Choice();
	String[] kujundid={"Ring thi", "Ring tidetud", "Ruut thi", "Ruut tidetud", "Joon", " - "};
		int allaX, allaY;

	Choice CopyPaste=new Choice();
	String[] CopyPasteMenu={" - ", "Lika", "Kopeeri", "Aseta"};

	Choice suurendamine=new Choice();
	String[] zoomin={"100%", "50%", "200%"};



	public PildiredaktorS(){
		tf.setText(nimi);
		addMouseListener(this);
		for(int i=0; i<zoomin.length; i++){
			suurendamine.addItem(zoomin[i]);
		}
		for(int i=0; i<varvinimed.length; i++){
			varvivalik.addItem(varvinimed[i]);
		}
		for(int i=0; i<kujundid.length; i++){
			kujundivalik.addItem(kujundid[i]);
		}
		for(int i=0; i<CopyPasteMenu.length; i++){
			CopyPaste.addItem(CopyPasteMenu[i]);
		}
		add(suurendamine);
		add(varvivalik);
		add(kujundivalik);
		add(CopyPaste);

		add(nupp1);
		nupp1.addActionListener(this);
		add(nupp2);
		nupp2.addActionListener(this);
		add(tf);
		tf.addActionListener(this);
		
	}


// Suurendamine ja Vhendamine (px=pildi x, py=pildi y)

	int ex(int px){
		return px*suurendus;
	}
	int ey(int py){
		return py*suurendus;
	}
	int px(int ex){
		return ex/suurendus;
	}
	int py(int ey){
		return ey/suurendus;
	}


// Paint

	public void paint(Graphics g){
		g.drawImage(pilt, 0, 0, pildilaius*suurendus, pildikorgus*suurendus, this);
	}


// Hoiab pildi vilkumise eemal

	public void update(Graphics g){paint(g);}


// MousePressed

	public void mousePressed(MouseEvent e){
		allaX=px(e.getX());
		allaY=py(e.getY());
		if(CopyPaste.getSelectedItem().equals("Aseta")){
			if(puhver!=null){
				piltg.drawImage(puhver, allaX, allaY, this);
				repaint();
			}
		}
	}


// MouseReleased

	public void mouseReleased(MouseEvent e){
		piltg.setColor(varvid[varvivalik.getSelectedIndex()]);
		int vyx=Math.min(allaX, px(e.getX()));		
		int vyy=Math.min(allaY, py(e.getY()));
		int laius=Math.abs(allaX-px(e.getX()));
		int korgus=Math.abs(allaY-py(e.getY()));

		if(CopyPaste.getSelectedItem().equals("Kopeeri")){
			kujundivalik.select(" - ");
			puhver=new BufferedImage(laius, korgus, BufferedImage.TYPE_INT_RGB);
			Graphics2D puhverg=puhver.createGraphics();
			puhverg.drawImage(pilt, -vyx, -vyy, this);
		}
		if(CopyPaste.getSelectedItem().equals("Lika")){
			kujundivalik.select(" - ");
			puhver=new BufferedImage(laius, korgus, BufferedImage.TYPE_INT_RGB);
			Graphics2D puhverg=puhver.createGraphics();
			puhverg.drawImage(pilt, -vyx, -vyy, this);

			piltg.setColor(Color.black);
			piltg.fillRect(vyx, vyy, laius, korgus);
			piltg.setColor(varvid[varvivalik.getSelectedIndex()]);
		}
		if(kujundivalik.getSelectedItem().equals("Ring thi")){
			piltg.drawOval(vyx, vyy, laius, korgus);
		}
		if(kujundivalik.getSelectedItem().equals("Ring tidetud")){
			piltg.fillOval(vyx, vyy, laius, korgus);
		}
		if(kujundivalik.getSelectedItem().equals("Ruut thi")){
			piltg.drawRect(vyx, vyy, laius, korgus);
		}
		if(kujundivalik.getSelectedItem().equals("Ruut tidetud")){
			piltg.fillRect(vyx, vyy, laius, korgus);
		}
		if(kujundivalik.getSelectedItem().equals("Joon")){
			piltg.drawLine(allaX, allaY, px(e.getX()), py(e.getY()));
		}
		if(suurendamine.getSelectedItem().equals("50%")){
			suurendus=1;
		}
		if(suurendamine.getSelectedItem().equals("100%")){
			suurendus=2;
		}
		if(suurendamine.getSelectedItem().equals("200%")){
			suurendus=3;
		}

		repaint();
	}

	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}


// ActionPerformed

	public void actionPerformed(ActionEvent e){
		try{
			if(e.getSource()==nupp1){
				FileOutputStream fos=new FileOutputStream(tf.getText());
				JPEGCodec.createJPEGEncoder(fos).encode(pilt);
				fos.close();
			}
			if(e.getSource()==nupp2){
				Image failipilt=Toolkit.getDefaultToolkit().getImage(tf.getText());
				MediaTracker md=new MediaTracker(this);
				md.addImage(failipilt, 0);
				md.waitForAll();
				piltg.drawImage(failipilt, 10, 20, this);
				repaint();
			}

		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public static void main(String argumendid[]){
		Frame f=new Frame("Vrvi ise! , Version 10(S) ;) , by Rnno Allikivi ");
		f.add(new PildiredaktorS());
		f.setSize(1024, 768);
		f.setVisible(true);
		f.addWindowListener(new Raami2kuular());
	}
}

class Raami2kuular extends WindowAdapter{
	public void windowClosing(WindowEvent e){
		System.exit(0);
	}
}