import java.awt.*;                        
import java.applet.Applet;
import java.awt.image.*;// pildi jaoks
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

/**
* Peaklass, meie programmi sda
*/
public class ilutulestik extends Applet implements MouseListener{  
Image taust=Toolkit.getDefaultToolkit().getImage("taevas.jpg"); //taust
 boolean hiirevajutus=false;
 static BufferedImage malupilt; 
public ilutulestik(){
     addMouseListener(this);  //kuulab hiirekest
   }
/**
* Reageerib hiirevajutusele ja rakett saab algkoordinaadid
*/   
public void mousePressed(MouseEvent e){
     int x=e.getX();          //saab algkoordinaadid
     int y=e.getY();
     if (hiirevajutus==false){
       hiirevajutus=true;
       repaint();
     }
   new ilutulestikLoim(x, y, getGraphics()).start();   //start paneb kima   
   }
   public void mouseReleased(MouseEvent e){}
   public void mouseEntered(MouseEvent e){}
   public void mouseExited(MouseEvent e){}
   public void mouseClicked(MouseEvent e){}         
    
    /**
    * Kaetakse le, et vltida tausta vilkumist
    */    
    public void update(Graphics g){
      paint(g);
    }
/**
* Joonistatakse taustapilt, kasutades mlupilti
*/    
public void paint(Graphics g){
      malupilt=new BufferedImage(                     //taustapildi joonistab
               getWidth(), getHeight(), BufferedImage.TYPE_INT_RGB);
     Graphics malug=malupilt.createGraphics();
     malug.drawImage(taust, 0, 0, getWidth(), getHeight(), this);
     g.drawImage(malupilt, 0, 0, this);
  if (hiirevajutus==false){
    g.setColor(Color.white);
    g.setFont (new Font("Times", Font.BOLD, 30));
    g.drawString("Kliki...  :)", 100,110);
    g.setFont (new Font("Times", Font.BOLD, 20));
    g.drawString("Made by Aveli, Airin & Maret, 2001", 650,700);
    g.setFont (new Font("Times", Font.BOLD, 60));
    g.drawString("ILUSAT UUT AASTAT !!", 200, 330);}
}
/**
* Programmi kivitus
*/
public static void main(String argumendid[]){     //kivitab programmi
    Frame f=new Frame("H E A D    U U T    A A S T A T  ! ! !");
    f.add(new ilutulestik());
    f.setSize(1000, 740);
    f.setVisible(true);
    f.addWindowListener(new Raamikuular());//selleks et kinni panna
  }
/**
* Teeb lime, kus annab igale raketile vrvi
*/
class ilutulestikLoim extends Thread{ // teeb ilutulestiku lime
  int x, y, ots; 
  Graphics g;
  Color a;
  public ilutulestikLoim(int ux, int uy, Graphics ug){ //annab uued koordinaadid, mida kasutab ainult lime sees
    x=ux; y=uy;
    g=ug;
    ots=y-100;
    Color[] Varvid=new Color[8];
    Varvid[0]=Color.yellow;
    Varvid[1]=Color.red;
    Varvid[2]=Color.green;
    Varvid[3]=Color.blue;
    Varvid[4]=Color.white;
    Varvid[5]=Color.gray;
    Varvid[6]=Color.magenta;
    Varvid[7]=Color.cyan;
    a=Varvid[(int)(Math.random()*8)];
      }
 
 /**
 * Kivitab hiirevajutuse peale raketi hkutusmise
 */
   public void run(){     
      for(; y>ots; y=y-6){  //hiirevajutuse peale alustab raketi tusmist
      g.setColor(a);
      g.setXORMode(Color.black);
      g.fillOval(x, y, 10, 10);
      
      try{
          Thread.sleep(30);
        }catch(Exception ex){}
        g.fillOval(x, y, 10, 10);
      }
  new koverLoim(x, y, g, -15,a).start(); //siit hakkab plahvatus
  new koverLoim(x, y, g, -5, a).start();
  new koverLoim(x, y, g, 0, a).start();
  new koverLoim(x, y, g, 5, a).start();
  new koverLoim(x, y, g, 15, a).start();
  new koverLoim(x, y, g, 25, a).start();
  new koverLoim(x, y, g, 35, a).start();
  new koverLoim(x, y, g, 45, a).start();
  new koverLoim(x, y, g, 55, a).start();
  new koverLoim(x, y, g, 65, a).start();
  new koverLoim(x, y, g, 75, a).start();
  new koverLoim(x, y, g, 85, a).start();
  new koverLoim(x, y, g, 90, a).start();
  new koverLoim(x, y, g, 95, a).start();
  new koverLoim(x, y, g, 105, a).start();
  new koverLoim(x, y, g, 115, a).start();
  new koverLoim(x, y, g, 125, a).start();
  new koverLoim(x, y, g, 135, a).start();
  new koverLoim(x, y, g, 145, a).start();
  new koverLoim(x, y, g, 155, a).start();
  new koverLoim(x, y, g, 165, a).start();
  new koverLoim(x, y, g, 175, a).start();
  new koverLoim(x, y, g, 180, a).start();
  new koverLoim(x, y, g, 185, a).start();
  new koverLoim(x, y, g, 195, a).start();
  }
  }
/**
* Loob plahvatuse
*/  
class koverLoim extends Thread{     //plahvatuse lim
   double x, y, ots;
   Graphics g;
   double nurk;
   Color a;
   public koverLoim(int ux, int uy, Graphics ug, double unurk, Color ua){
   x=ux; y=uy;
   g=ug;
   a=ua; 
   ots=y+200;
   nurk=unurk;
}
/**
* Kivitab plahvatuse
*/
public void run(){  // paneb kima plahvatuse lime
    double kiirus=10; //mida suurem kiirus, seda suurem kaar
    double kiirusx=Math.cos(Math.toRadians(nurk))*kiirus;
    double kiirusy=-Math.sin(Math.toRadians(nurk))*kiirus;
    double kiirendusy=0.5; // mida viksem seda kiirem
    while (y<ots){
      g.setColor(a);       //joonistatakse kollane vike ring
      g.setXORMode(Color.black);  //joonistab kollase peale musta ja musta peale kollase
      g.fillOval((int)x, (int)y, 5, 5);
      try{Thread.sleep(50);}catch(Exception e){} //oodatakse veidi
      g.fillOval((int)x, (int)y, 5, 5);     //joonistatakse uuesti
      y=y+kiirusy;
      x=x+kiirusx;
      kiirusy=kiirusy+kiirendusy;
    }
   }
  }
}
/**
* Vimaldab sulgeda raami paremal lal olevast ristist
*/
class Raamikuular extends WindowAdapter{   // saab sulgeda raami otse, st ristist levalt         
                 public void windowClosing(WindowEvent e){
                         System.exit(0);
            }
    }

